Wt: Wt::WMenu Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions
Wt::WMenu Class Reference

A widget that shows a menu of options. More...

`#include <Wt/WMenu>`

Inheritance diagram for Wt::WMenu:
[legend]

List of all members.

## Public Member Functions
| WMenu (Orientation orientation, WContainerWidget *parent=0)
| Creates a new menu (deprecated).
| WMenu (WContainerWidget *parent=0)
| Creates a new menu.
| WMenu (WStackedWidget *contentsStack, Orientation orientation, WContainerWidget *parent=0)
| Creates a new menu (deprecated).
| WMenu (WStackedWidget *contentsStack, WContainerWidget *parent=0)
| Creates a new menu.
| ~WMenu ()
| Destructor.
WMenuItem * | addItem (const WString &label, WWidget *contents=0, WMenuItem::LoadPolicy policy=WMenuItem::LazyLoading)
| Adds an item.
WMenuItem * | addItem (const std::string &iconPath, const WString &label, WWidget *contents=0, WMenuItem::LoadPolicy policy=WMenuItem::LazyLoading)
| Adds an item.
template<class T , class V >
WMenuItem * | addItem (const WString &text, T *target, void(V::*method)())
| Adds an item with given text, and specify a slot method to be called when the item is triggered.
template<class T , class V >
WMenuItem * | addItem (const std::string &iconPath, const WString &text, T *target, void(V::*method)())
| Adds an item with given text and icon, and specify a slot method to be called when activated.
WMenuItem * | addMenu (const WString &text, WMenu *menu)
| Adds a submenu, with given text.
WMenuItem * | addMenu (const std::string &iconPath, const WString &text, WMenu *menu)
| Adds a submenu, with given icon and text.
void | addItem (WMenuItem *item)
| Adds an item.
void | addSeparator ()
| Adds a separator to the menu.
void | addSectionHeader (const WString &text)
| Adds a section header to the menu.
void | removeItem (WMenuItem *item)
| Removes an item.
void | select (WMenuItem *item)
| Selects an item.
void | select (int index)
| Selects an item.
Signal< WMenuItem * > & | itemSelected ()
| Signal which indicates that a new item was selected.
Signal< WMenuItem * > & | itemSelectRendered ()
| Signal which indicates that a new selected item is rendered.
void | close (WMenuItem *item)
| Closes an item.
void | close (int index)
| Closes an item.
std::vector< WMenuItem * > | items () const
| Returns the items.
Signal< WMenuItem * > & | itemClosed ()
| Signal which indicates that an item was closed.
void | setItemHidden (WMenuItem *item, bool hidden)
| Hides an item.
void | setItemHidden (int index, bool hidden)
| Hides an item.
bool | isItemHidden (WMenuItem *item) const
| Returns whether the item widget of the given item is hidden.
bool | isItemHidden (int index) const
| Returns whether the item widget of the given index is hidden.
void | setItemDisabled (WMenuItem *item, bool disabled)
| Disables an item.
void | setItemDisabled (int index, bool disabled)
| Disables an item.
bool | isItemDisabled (WMenuItem *item) const
| Returns whether the item widget of the given item is disabled.
bool | isItemDisabled (int index) const
| Returns whether the item widget of the given index is disabled.
WMenuItem * | currentItem () const
| Returns the currently selected item.
int | currentIndex () const
| Returns the index of the currently selected item.
Orientation | orientation () const
| Returns the orientation (deprecated).
void | setRenderAsList (bool enable)
| Renders using an HTML list (deprecated)
bool | renderAsList () const
| Returns whether the menu is rendered as an HTML list (deprecated).
void | setInternalPathEnabled (const std::string &basePath="")
| Enables internal paths for items.
bool | internalPathEnabled () const
| Returns whether the menu generates internal paths entries.
void | setInternalBasePath (const std::string &basePath)
| Sets the internal base path.
const std::string & | internalBasePath () const
| Returns the internal base path.
WStackedWidget * | contentsStack () const
| Returns the contents stack associated with the menu.
## Protected Member Functions
virtual void | render (WFlags< RenderFlag > flags)
| Renders the widget.
virtual void | internalPathChanged (const std::string &path)
| Handling of internal path changes.
virtual int | nextAfterHide (int index)
| Returns the index of the item to be selected after hides.

## Detailed Description

A widget that shows a menu of options.

The WMenu widget offers menu navigation.

Typically, a menu is used in conjunction with a WStackedWidget (but can be used without too), where different 'contents' are stacked upon each other. Each choice in the menu (which is implemented as a WMenuItem) corresponds to a tab in the contents stack. The contents stack may contain other items, and could be shared with other WMenu instances.

When used without a contents stack, you can react to menu item selection using the itemSelected() signal, to implement some custom handling of item selection.

Usage example:

     // create the stack where the contents will be located
     Wt::WStackedWidget *contents = new Wt::WStackedWidget(contentsParent);

     // create a menu
     Wt::WMenu *menu = new Wt::WMenu(contents, menuParent);

     // add four items using the default lazy loading policy.
     menu->addItem("Introduction", new Wt::WText("intro"));
     menu->addItem("Download", new Wt::WText("Not yet available"));
     menu->addItem("Demo", new DemoWidget());
     menu->addItem(new Wt::WMenuItem("Demo2", new DemoWidget()));

After contruction, the first entry will be selected. At any time, it is possible to select a particular item using select().

Each item of WMenu may be closeable (see WMenuItem::setCloseable(bool). Like selection, at any time, it is possible to close a particular item using close(). You can react to close of item by using the itemClosed() signal.

The WMenu implementation offers fine-grained control on how contents should be preloaded. By default, all contents is lazy-loaded, only when needed. To improve response time, an item may also be preloaded (using addItem()). In that case, the item will be loaded in the background, before its first use. In any case, once the contents corresponding to a menu item is loaded, subsequent navigation to it is handled entirely client-side.

The WMenu may participate in the application's internal path, which lets menu items correspond to internal URLs, see setInternalPathEnabled().

The layout of the menu may be Horizontal or Vertical. The look of the items may be defined through style sheets. The default WMenuItem implementation uses four style classes to distinguish between inactivated, activated, closeable inactivated and closeable activated menu items: `"item"`, `"itemselected"`, `"citem"`, `"citemselected"`. By using CSS nested selectors, a different style may be defined for items in a different menu.

You may customize the rendering and behaviour of menu entries by specializing WMenuItem.

### CSS

The menu is rendered as a >ul<. Unless you use the bootstrap theme, you will want to customize the menu using inline or external styles to hide the bullets and provide the appropriate horizontal or vertical layout.

See also:
  WMenuItem

## Constructor & Destructor Documentation

Wt::WMenu::WMenu | ( | Orientation | orientation,
|  | WContainerWidget * | parent = `0`
| ) |  |

Creates a new menu (deprecated).

Construct a menu with given `orientation`. The menu is not associated with a contents stack, and thus you will want to react to the itemSelected() signal to react to menu changes.

Deprecated:
  the `orientation` parameter is ignored, since menus are now always rendered using <ul> elements, and CSS will determine the orientation. Use WMenu(WContainerWidget *) instead.

Wt::WMenu::WMenu | ( | WContainerWidget * | parent = `0` | ) |

Creates a new menu.

The menu is not associated with a contents stack, and thus you will want to react to the itemSelected() signal to react to menu changes.

Wt::WMenu::WMenu | ( | WStackedWidget * | contentsStack,
|  | Orientation | orientation,
|  | WContainerWidget * | parent = `0`
| ) |  |

Creates a new menu (deprecated).

Construct a menu to manage the widgets in `contentsStack`, and sets the menu `orientation`.

Each menu item will manage a single widget in the `contentsStack`, making it the current widget when the menu item is activated.

Deprecated:
  the `orientation` parameter is ignored, since menus are now always rendered using <ul> elements, and CSS will determine the orientation. Use WMenu(WStackedWidget *contentsStack, WContainerWidget *) instead.

Wt::WMenu::WMenu | ( | WStackedWidget * | contentsStack,
|  | WContainerWidget * | parent = `0`
| ) |  |

Creates a new menu.

Construct a menu to manage the widgets in `contentsStack`.

Each menu item will manage a single widget in the `contentsStack`, making it the current widget when the menu item is activated.

## Member Function Documentation

WMenuItem * Wt::WMenu::addItem | ( | const WString & | label,
|  | WWidget * | contents = `0`,
|  | WMenuItem::LoadPolicy | policy = `WMenuItem::LazyLoading`
| ) |  |

Adds an item.

Use this version of addItem() if you do not want to specify an icon for this menu item.

Returns the corresponding WMenuItem.

See also:
  addItem(const std::string&, const WString&, WWidget *, WMenuItem::LoadPolicy)
  addItem(WMenuItem *)

WMenuItem * Wt::WMenu::addItem | ( | const std::string & | iconPath,
|  | const WString & | label,
|  | WWidget * | contents = `0`,
|  | WMenuItem::LoadPolicy | policy = `WMenuItem::LazyLoading`
| ) |  |

Adds an item.

Adds a menu item with given `contents`, which is added to the menu's associated contents stack.

`contents` may be `0` for two reasons:

- if the menu is not associated with a contents stack, then you cannot associate a menu item with a contents widget
- or, you may have one or more items which which are not associated with a contents widget in the contents stack.

Returns the corresponding WMenuItem.

See also:
  addItem(WMenuItem *)

template<class T , class V >

WMenuItem * Wt::WMenu::addItem | ( | const WString & | text,
|  | T * | target,
|  | void(V::*)() | method
| ) |  |

Adds an item with given text, and specify a slot method to be called when the item is triggered.

The target and `method` are connected to the WMenuItem::triggered signal.

See also:
  add(WMenuItem *)

template<class T , class V >

WMenuItem * Wt::WMenu::addItem | ( | const std::string & | iconPath,
|  | const WString & | text,
|  | T * | target,
|  | void(V::*)() | method
| ) |  |

Adds an item with given text and icon, and specify a slot method to be called when activated.

The target and `method` are connected to the WMenuItem::triggered signal.

Note:
  The icon should have a width of 16 pixels.

See also:
  add(WMenuItem *)

void Wt::WMenu::addItem | ( | WMenuItem * | item | ) |

Adds an item.

Adds a menu item. Use this form to add specialized WMenuItem implementations.

See also:
  addItem(const WString&, WWidget *, WMenuItem::LoadPolicy)

WMenuItem * Wt::WMenu::addMenu | ( | const WString & | text,
|  | WMenu * | menu
| ) |  |

Adds a submenu, with given text.

Adds an item with text `text`, that leads to a submenu `menu`.

See also:
  add(WMenuItem *)

WMenuItem * Wt::WMenu::addMenu | ( | const std::string & | iconPath,
|  | const WString & | text,
|  | WMenu * | menu
| ) |  |

Adds a submenu, with given icon and text.

Adds an item with given text and icon, that leads to a submenu `menu`.

See also:
  add(WMenuItem *)

void Wt::WMenu::addSeparator | ( |  | ) |

Adds a separator to the menu.

Adds a separator the menu.

void Wt::WMenu::close | ( | WMenuItem * | item | ) |

Closes an item.

Close the menu item `item`. Only closeable items can be closed.

See also:
  close(int), WMenuItem::close()

void Wt::WMenu::close | ( | int | index | ) |

Closes an item.

Menu items in a menu with `N` items are numbered from 0 to `N` - 1.

See also:
  close(WMenuItem *)

int Wt::WMenu::currentIndex | ( |  | ) | const

Returns the index of the currently selected item.

See also:
  currentItem(), select(int)

WMenuItem * Wt::WMenu::currentItem | ( |  | ) | const

Returns the currently selected item.

See also:
  currentIndex(), select(WMenuItem *)

const std::string& Wt::WMenu::internalBasePath | ( |  | ) | const

Returns the internal base path.

The default value is the application's internalPath (WApplication::internalPath()) that was recorded when setInternalPathEnabled() was called, and together with each WMenuItem::pathComponent() determines the paths for each item.

For example, if internalBasePath() is `"/examples/"` and pathComponent() for a particular item is `"charts/"`, then the internal path for that item will be `"/examples/charts/"`.

See also:
  setInternalPathEnabled()

void Wt::WMenu::internalPathChanged | ( | const std::string & | path | ) | `[protected, virtual]`

Handling of internal path changes.

This methods makes the menu react to internal path changes (and also the initial internal path).

You may want to reimplement this if you want to customize the internal path handling.

bool Wt::WMenu::internalPathEnabled | ( |  | ) | const

Returns whether the menu generates internal paths entries.

See also:
  setInternalPathEnabled()

bool Wt::WMenu::isItemDisabled | ( | WMenuItem * | item | ) | const

Returns whether the item widget of the given item is disabled.

See also:
  setItemDisabled()

bool Wt::WMenu::isItemDisabled | ( | int | index | ) | const

Returns whether the item widget of the given index is disabled.

Menu items in a menu with `N` items are numbered from 0 to `N` - 1.

See also:
  setItemDisabled()

bool Wt::WMenu::isItemHidden | ( | WMenuItem * | item | ) | const

Returns whether the item widget of the given item is hidden.

See also:
  setItemHidden()

bool Wt::WMenu::isItemHidden | ( | int | index | ) | const

Returns whether the item widget of the given index is hidden.

Menu items in a menu with `N` items are numbered from 0 to `N` - 1.

See also:
  setItemHidden()

Signal<WMenuItem *>& Wt::WMenu::itemClosed | ( |  | ) |

Signal which indicates that an item was closed.

This signal is emitted when an item was closed. It is emitted both when the user closes an item, or when close() was invoked.

std::vector< WMenuItem * > Wt::WMenu::items | ( |  | ) | const

Returns the items.

Returns the list of menu items in this menu.

See also:
  itemAt()

Signal<WMenuItem *>& Wt::WMenu::itemSelected | ( |  | ) |

Signal which indicates that a new item was selected.

This signal is emitted when an item was selected. It is emitted both when the user activated an item, or when select() was invoked.

See also:
  itemSelectRendered()

Signal<WMenuItem *>& Wt::WMenu::itemSelectRendered | ( |  | ) |

Signal which indicates that a new selected item is rendered.

This signal is similar to itemSelected, but is emitted from within a stateless slot. Therefore, any slot connected to this signal will be optimized to client-side JavaScript, and must support the contract of a stateless slot (i.e., be idempotent).

If you are unsure what is the difference with the itemSelected signal, you'll probably need the latter instead.

See also:
  itemSelected()

int Wt::WMenu::nextAfterHide | ( | int | index | ) | `[protected, virtual]`

Returns the index of the item to be selected after hides.

Returns the index of the item to be selected after the item with given index will be hidden.

By default, if the given index is an index of currently selected item, returns an index of the first visible item to the right of it. If it is not found, returns the index of the first visible item to the left of it. If there are no visible items around the currently selected item, returns the index of currently selected item.

You may want to reimplement this if you want to customize the algorithm of determining the index of the item to be selected after hiding the item with given index.

Orientation Wt::WMenu::orientation | ( |  | ) | const

Returns the orientation (deprecated).

The orientation is set at time of construction.

Deprecated:
  this function no longer has any use and will be removed.

void Wt::WMenu::removeItem | ( | WMenuItem * | item | ) |

Removes an item.

Removes the given item. The item and its contents is not deleted.

See also:
  addItem()

void Wt::WMenu::render | ( | WFlags< RenderFlag > | flags | ) | `[protected, virtual]`

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WCompositeWidget.

bool Wt::WMenu::renderAsList | ( |  | ) | const

Returns whether the menu is rendered as an HTML list (deprecated).

Deprecated:
  this function no longer has any use and will be removed.

void Wt::WMenu::select | ( | WMenuItem * | item | ) |

Selects an item.

Select the menu item `item`.

When `item` is `0`, the current selection is removed.

See also:
  select(int), currentItem(), WMenuItem::select()

void Wt::WMenu::select | ( | int | index | ) |

Selects an item.

Menu items in a menu with `N` items are numbered from 0 to `N` - 1.

Using a value of -1 removes the current selection.

See also:
  select(WMenuItem *), currentIndex()

void Wt::WMenu::setInternalBasePath | ( | const std::string & | basePath | ) |

Sets the internal base path.

A '/' is appended to turn it into a folder, if needed.

See also:
  setInternalPathEnabled(), internalBasePath()

void Wt::WMenu::setInternalPathEnabled | ( | const std::string & | basePath = `""` | ) |

Enables internal paths for items.

The menu participates in the internal path by changing the internal path when an item has been selected, and listening for path changes to react to path selections. As a consequence this allows the user to bookmark the current menu selection and revisit it later, use back/forward buttons to navigate through history of visited menu items, and allows indexing of pages.

For each menu item, WMenuItem::pathComponent() is appended to the `basePath`, which defaults to the internal path (WApplication::internalPath()). A '/' is appended to the base path, to turn it into a folder, if needed.

By default, menu interaction does not change the application internal path.

See also:
  WMenuItem::setPathComponent().

void Wt::WMenu::setItemDisabled | ( | WMenuItem * | item,
|  | bool | disabled
| ) |  |

Disables an item.

Disables the menu item `item`. Only an item that is enabled can be selected. By default, all menu items are enabled.

See also:
  setItemDisabled(int, bool), WMenuItem::setDisabled()

void Wt::WMenu::setItemDisabled | ( | int | index,
|  | bool | disabled
| ) |  |

Disables an item.

Menu items in a menu with `N` items are numbered from 0 to `N` - 1.

See also:
  setItemDisabled(WMenuItem *, bool)

void Wt::WMenu::setItemHidden | ( | WMenuItem * | item,
|  | bool | hidden
| ) |  |

Hides an item.

Hides the menu item `item`. By default, all menu items are visible.

If the item was currently selected, then the next item to be selected is determined by nextAfterHide().

See also:
  setItemHidden(int, bool), WMenuItem::hide()

void Wt::WMenu::setItemHidden | ( | int | index,
|  | bool | hidden
| ) |  |

Hides an item.

Menu items in a menu with `N` items are numbered from 0 to `N` - 1.

See also:
  setItemHidden(WMenuItem *, bool)

void Wt::WMenu::setRenderAsList | ( | bool | enable | ) |

Renders using an HTML list (deprecated)

This function no longer has an effect, as a menu is now always rendered as a list.

Deprecated:
  this function no longer has any use and will be removed.

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator